import { select } from 'd3';
import { barChart } from './barChart';
import { pieChart } from './pieChart';
import { dropdownMenu } from './dropdownMenu';


const data = [{note: "sehr gut", student: "master"},
              {note: "sehr gut", student: "master"},
              {note: "sehr gut", student: "bachelor"},
              {note: "sehr gut", student: "bachelor"},
							{note: "sehr gut", student: "bachelor"},
              {note: "sehr gut", student: "bachelor"},
              {note: "gut", student: "master"},
              {note: "gut", student: "master"},
              {note: "gut", student: "master"},
              {note: "gut", student: "master"},
              {note: "gut", student: "bachelor"},
              {note: "gut", student: "bachelor"},
              {note: "gut", student: "bachelor"},
              {note: "gut", student: "bachelor"},
              {note: "gut", student: "bachelor"},
              {note: "befriedigend", student: "master"},
              {note: "befriedigend", student: "master"},
              {note: "befriedigend", student: "master"},
              {note: "befriedigend", student: "master"},
              {note: "befriedigend", student: "master"},
              {note: "befriedigend", student: "master"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "befriedigend", student: "bachelor"},
              {note: "ausreichend", student: "master"},
              {note: "ausreichend", student: "master"},
              {note: "ausreichend", student: "master"},
              {note: "ausreichend", student: "master"},
              {note: "ausreichend", student: "master"},
              {note: "ausreichend", student: "bachelor"},
              {note: "ausreichend", student: "bachelor"},
              {note: "ausreichend", student: "bachelor"},
              {note: "ausreichend", student: "bachelor"},
              {note: "ausreichend", student: "bachelor"},
              {note: "ausreichend", student: "bachelor"},
              {note: "ausreichend", student: "bachelor"},
              {note: "ausreichend", student: "bachelor"}]

let catSpalten = ["note", "student"]

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

//absolute Häufigkeit der ersten Kategoriespalte berechnen
let abs = d3.nest().key(d => d[catSpalten[0]]).rollup(d => d.length).entries(data)

//sortieren des Arrays nach dem Wert der absoluten Häufigkeit absteigend
//wird gemacht damit Paths im Kreisdiagramm auch sortiert sind
abs.sort( (a, b) => b.value - a.value )

let xColumn = catSpalten[0];

const onXColumnClicked = column => {
	xColumn = column;
  //absolute Häufigkeit für ausgewählte Spalte berechnen
  abs = d3.nest().key(d => d[column]).rollup(d => d.length).entries(data)
  //an dieser Stelle auch wieder absteigend sortieren
  abs.sort( (a, b) => b.value - a.value )
  //an dieser Stelle werden alle path elemente gelöscht, weil
  //ansonsten beim Wechsel der Daten (dropdownMenu) ein bug mit
  //der Animation eintritt
  d3.selectAll('path').remove()
  render();
};

const render = () => {
  
  select('#x-menu')
	.call(dropdownMenu, {
		options: catSpalten,
    onOptionClicked: onXColumnClicked,
    selectedOption: xColumn
  	});
  
  /*svg.call(barChart, {
  	yValue: d => d.value,
    xValue: d => d[xColumn],
    xAxisLabel: xColumn,
   	margin: {top: 60, right: 40, bottom: 100, left: 130},
    width,
    height,
    data: abs
  })*/
  
  svg.call(pieChart, {
  	margin: {top: 60, right: 40, bottom: 100, left: 130},
    width,
    height,
    data: abs
  })

}

re