import { 
  select,
  schemeCategory10
       } from 'd3';

export const pieChart = (selection, props) => {
	const {
   	margin,
    width,
    height,
    data
  } = props
  
	const innerWidth = width - margin.left - margin.right;
	const innerHeight = height - margin.top - margin.bottom;
  
  let colorScale = d3.scaleOrdinal(schemeCategory10)
  	.domain(data.map(d => d.key))
	
  let pie = d3.pie()
  	.value(function(d) {return d.value; })
  	//nicht benötigt da Array bereits vorher sortiert wird
  	//.sortValues(function(a, b) { return b - a; })
  
  let radius = Math.min(innerWidth, innerHeight) / 2;
  
  let arc = d3.arc()
  	.innerRadius(0)
    .outerRadius(radius)
  
  console.log(data)
  let data_ready = pie(data)
  console.log(data_ready)
  
  const g = selection.selectAll('.contain').data([null]);
  const gEnter = g.enter().append('g')
  .attr('class', 'contain');
  
  gEnter
    .merge(g)
  		.attr('transform',
            `translate(${width/ 2},${height / 2})`
           );
  
  const paths = g.merge(gEnter).selectAll('path').data(data_ready);
  paths.enter().append('path')
  		.attr("stroke", "black")
  		.style("stroke-width", "2px")
  		.style("opacity", 0)
  		.attr('fill', 'white')
  	.merge(paths)
  		.transition().delay(function(d,i) {
					return i * 500; }).duration(500)
			.attrTween('d', function(d) {
					var i = d3.interpolate(d.startAngle + 0.1, d.endAngle);
					return function(t) {
						d.endAngle = i(t); 
						return arc(d)}})
  		//.attr('d', arc)
  		.attr('fill', d => colorScale(d.data.key))
  		.style("opacity", 0.7)
  paths.exit().remove()
  
  /*.transition().delay(function(d,i) {
	return i * 500; }).duration(500)
	.attrTween('d', function(d) {
		var i = d3.interpolate(d.startAngle+0.1, d.endAngle);
		return function(t) {
			d.endAngle = i(t); 
			return arc(d)
			}*/
  
  
  function arcTween(newAngle) {
  return function(d) {
     let interpolate = d3.interpolate(d.endAngle, newAngle);
    	return function(t) {
        d.endAngle = interpolate(t);
        return arc(d);
        };
  };
}
  			
	